/*
 * main.c
 * 
 * Copyright 2023 Guillaume Saumure <gsaumure@cgocable.ca>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "EasyString.h"

int main(int argc, char **argv)
{
	
	EasyString ESA, ESB, ESC;
	EasyString_Init(&ESA, NULL);
	EasyString_Init(&ESB, "26-10-2023");
	EasyString_Init(&ESC, NULL);
	
	EasyString* ESD = EasyString_New("25-10-2023");
	EasyString* ESE = EasyString_New("24-10-2023");
	
	ESA.vtable->Move(&ESA, &ESB);
	ESC.vtable->Move(&ESC, ESD);
	ESE->vtable->Move(ESE, &ESC);
	
	
	
	printf("%s (%ld)\n", ESA.vtable->GetBuffer(&ESA), ESA.vtable->Length(&ESA));
	printf("%s (%ld)\n", ESC.vtable->GetBuffer(&ESC), ESC.vtable->Length(&ESC));
	printf("%s (%ld)\n", ESE->vtable->GetBuffer(ESE), ESE->vtable->Length(ESE));
	
	ESA.vtable->Wipeout(&ESA);
	ESB.vtable->Wipeout(&ESB);
	ESC.vtable->Wipeout(&ESC);
	ESD->vtable->Destructor(ESD);
	
	EasyString* ES00 = EasyString_New("Allô le monde.");
	EasyString* ES01 = ES00->vtable->Left(ES00, 4);
	EasyString* ES02 = EasyString_New("Allo le monde.");
	EasyString* ES03 = ES02->vtable->Left(ES02, 4);
	
	EasyString* ES04 = ES00->vtable->Copy(ES00);
	EasyString* ES05 = ES00->vtable->Copy(ES00);
	EasyString* ES06 = ES01->vtable->Right(ES01, 3);
	EasyString* ES07 = ES03->vtable->Right(ES03, 3);
	
	EasyString* ES08 = EasyString_New("Allô le monde.");
	EasyString* ES09 = EasyString_New(" Allô");
	ES08->vtable->Insert(ES08, ES09, 4);
	
	EasyString* ES10 = ES08->vtable->Copy(ES08);
	
	ES10->vtable->Remove(ES10, ES09);
	
	EasyString* ES11 = EasyString_New(NULL);
	ES11->vtable->StrF(ES11, 3.14159265);
	float Value = ES11->vtable->ValF(ES11);
	
	EasyString* ES12 = EasyString_New("EasyBasic");
	
	EasyString* ES13 = ES12->vtable->Mid(ES12, 4, 5);
	EasyString* ES14 = EasyString_New(" ");
	
	EasyString* ES15 = ES00->vtable->Split(ES00, 1, ES14);
	EasyString* ES16 = ES00->vtable->Split(ES00, 2, ES14);
	EasyString* ES17 = ES00->vtable->Split(ES00, 3, ES14);
	
	ES04->vtable->LCase(ES04);
	ES05->vtable->UCase(ES05);

	printf("%s (%ld)\n", ES00->vtable->GetBuffer(ES00), ES00->vtable->Length(ES00));
	printf("%s (%ld)\n", ES01->vtable->GetBuffer(ES01), ES01->vtable->Length(ES01));
	printf("%s (%ld)\n", ES02->vtable->GetBuffer(ES02), ES02->vtable->Length(ES02));
	printf("%s (%ld)\n", ES03->vtable->GetBuffer(ES03), ES03->vtable->Length(ES03));
	printf("%s (%ld)\n", ES04->vtable->GetBuffer(ES04), ES04->vtable->Length(ES04));
	printf("%s (%ld)\n", ES05->vtable->GetBuffer(ES05), ES05->vtable->Length(ES05));
	printf("%s (%ld)\n", ES06->vtable->GetBuffer(ES06), ES06->vtable->Length(ES06));
	printf("%s (%ld)\n", ES07->vtable->GetBuffer(ES07), ES07->vtable->Length(ES07));
	printf("%s (%ld)\n", ES08->vtable->GetBuffer(ES08), ES08->vtable->Length(ES08));
	printf("%s (%ld)\n", ES09->vtable->GetBuffer(ES09), ES09->vtable->Length(ES09));
	printf("%s (%ld)\n", ES10->vtable->GetBuffer(ES10), ES10->vtable->Length(ES10));
	printf("%s (%ld)\n", ES11->vtable->GetBuffer(ES11), ES11->vtable->Length(ES11));
	
	printf("%0.9f\n", Value);
	
	printf("%s (%ld)\n", ES12->vtable->GetBuffer(ES12), ES12->vtable->Length(ES12));
	printf("%s (%ld)\n", ES13->vtable->GetBuffer(ES13), ES13->vtable->Length(ES13));
	
	printf("%s (%ld)\n", ES15->vtable->GetBuffer(ES15), ES15->vtable->Length(ES15));
	printf("%s (%ld)\n", ES16->vtable->GetBuffer(ES16), ES16->vtable->Length(ES16));
	printf("%s (%ld)\n", ES17->vtable->GetBuffer(ES17), ES17->vtable->Length(ES17));
	
	ES00->vtable->Destructor(ES00);
	ES01->vtable->Destructor(ES01);
	ES02->vtable->Destructor(ES02);
	ES03->vtable->Destructor(ES03);
	ES04->vtable->Destructor(ES04);
	ES05->vtable->Destructor(ES05);
	ES06->vtable->Destructor(ES06);
	ES07->vtable->Destructor(ES07);
	ES08->vtable->Destructor(ES08);
	ES09->vtable->Destructor(ES09);
	ES10->vtable->Destructor(ES10);
	ES11->vtable->Destructor(ES11);
	ES12->vtable->Destructor(ES12);
	ES13->vtable->Destructor(ES13);
	ES14->vtable->Destructor(ES14);
	ES15->vtable->Destructor(ES15);
	ES16->vtable->Destructor(ES16);
	ES17->vtable->Destructor(ES17);
	
	return 0;
}

